#-*- Makefile -*-

require DE_EPAGES::Core::API::Makefile;
__DATA__
#
#   makefile
#
#   Project : epages 6
#   Copyright   : ePages GmbH 2004
#   Version : Fri Dec 03 17:07:43 2010
#

!OS_SPECIFIC_DEFINES
DE_EPAGES   = .
COMPANY     = DE_EPAGES
STORE       = YourStore
SOURCEDOC   = $(MAKEDIR)\..\SourceDoc
SOURCEDOCDATE= Mon May 3 12:00:00 2012
EPAGES_VERSION_NUMBER= 6.17.4
EPAGES_VERSION= ePages $(EPAGES_VERSION_NUMBER)
EPAGES_TAG  = release_6_17_4
#  ePagesJ release version:
#  - Use latest version available for MAIN. Should be the same as
#    $EPAGES_VERSION_NUMBER, but might be -1.
#  - Use equal version for pre-release branch.
EPAGESJ_VERSION= 6.17.4
EPAGES_NODEJS_VERSION= 6.17.4
!ifndef PATCH_TAG
PATCH_TAG   = $(EPAGES_TAG)
!endif
SITE_NAME   = Site
STORE_TYPE  = Store
SITE_TYPE   = Site
!ifndef BASE_STORE_TYPE
BASE_STORE_TYPE = $(STORE_TYPE)
!endif
!ifndef BASE_SITE_TYPE
BASE_SITE_TYPE = $(SITE_TYPE)
!endif
BACKUP_NAME = Backup
PROVIDER_PATH = /Providers/Distributor
PROVIDER_USER = admin
PROVIDER_PASSWD = admin
DEMOSHOP_ALIAS = DemoShop
DEMOSHOP_SHOPTYPE = Demo
CARTRIDGE=ALL
# settings for multistore installations
MASTER_NAME  = Master
MASTER_TYPE  = Master
MULTISTORE_NAME  = MultiStore
MULTISTORE_TYPE  = MultiStore
MULTISTORESITE_TYPE  = MultiStoreSite
MASTER_PROVIDER_PATH = $(PROVIDER_PATH)
MULTISTORE_PROVIDER_PATH = $(PROVIDER_PATH)
MASTER_PROVIDER_USER = $(PROVIDER_USER)
MULTISTORE_PROVIDER_USER = $(PROVIDER_USER)
MASTER_PROVIDER_PASSWD = $(PROVIDER_PASSWD)
MULTISTORE_PROVIDER_PASSWD = $(PROVIDER_PASSWD)
MASTERSHOP_ALIAS = MasterShop
MASTERSHOP_SHOPTYPE = Demo
SUBSHOP_ALIAS_DROPSHIPPING = DropShipping
SUBSHOP_SHOPTYPE_DROPSHIPPING = DropShipping1000
SUBSHOP_ALIAS_ERETAIL = eRetail
SUBSHOP_SHOPTYPE_ERETAIL = ERetail1000
ORDER_INTEGRATION_DROPSHIPPING = BasketHandover
ORDER_INTEGRATION_ERETAIL = OrderSplitting

!ifeq ("$(BASE_STORE_TYPE)", "FlexStore")
IMPORT_STORE	=
!else
IMPORT_STORE	= import_store
!endif

!ifdef WINDOWS
NPM_EXE		= npm
IF_EXIST	= if exist
IF_NOT_EXIST	= if not exist
DO		=
!else
NPM_EXE		= $(EPAGES_PERL)/bin/npm.sh
!ifeq ("$(EPAGES_PROJECT)", "")
EPAGES_PROJECT	= epages6
!endif
SHELL		= /bin/bash
IF_EXIST	= [ ! -e
IF_NOT_EXIST	= [ -e
DO		= ] ||
EP_WEB_GROUP  = $(shell echo $${EPAGES_WEBGROUP:-ep_web} | sed 's/:.*//')
!endif
MODULES_INI   = $(EPAGES_CARTRIDGES)\CPAN\EPAGES\PerlLib\$(OSNAME)\modules.ini

!ifndef PATCH_DIR
PATCH_DIR   = $(EPAGES_SHARED)\Patches\$(EPAGES_TAG)
!endif
DATA_DIR    = $(EPAGES_SHARED)\var-$(EPAGES_TAG)
BACKUP_DIR  = $(DATA_DIR)\backup\$(HOSTNAME)
LOG_DIR     = $(DATA_DIR)\logs\$(HOSTNAME)
TGT         = $(DATA_DIR)\tgt\$(HOSTNAME)

IMPORT      = $(PERL) $(DE_EPAGES)/Object/Scripts/import.pl -storename=$(STORE)
DELETE      = $(PERL) $(DE_EPAGES)/Object/Scripts/delete.pl -storename=$(STORE)
DBDUMPS     = $(PERL) $(DE_EPAGES)/Database/Scripts/DatabaseDumps.pl
PATCHFILES  = $(PERL) $(DE_EPAGES)/Core/Scripts/PatchFiles.pl
PATCHDB     = $(PERL) $(DE_EPAGES)/Installer/Scripts/patchDatabase.pl
CREATEDB    = $(PERL) $(DE_EPAGES)/Database/Scripts/createDB.pl
DROPDB      = $(PERL) $(DE_EPAGES)/Database/Scripts/dropDB.pl
INSTALLDB   = $(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/installDatabase.pl
REGISTER    = $(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/registercartridges.pl
SYNC        = $(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/synccartridges.pl
DROPTABLES  = $(PERL) $(DE_EPAGES)/Database/Scripts/dropAllTables.pl
STOREREDIRECT= $(PERL) $(DE_EPAGES)/Database/Scripts/redirectStoreConnections.pl
DEL_INI_SECTION= $(PERL) $(DE_EPAGES)/Core/Scripts/DelIniSection.pl
INSTALL_CPAN= $(PERL) $(DE_EPAGES)/Installer/Scripts/installCPAN.pl
START_EPAGES= $(PERL) $(DE_EPAGES)/Installer/Scripts/startService.pl epages
STOP_EPAGES = $(PERL) $(DE_EPAGES)/Installer/Scripts/stopService.pl epages
START_CRON  = $(PERL) $(DE_EPAGES)/Installer/Scripts/startService.pl cron
STOP_CRON   = $(PERL) $(DE_EPAGES)/Installer/Scripts/stopService.pl cron
INSTALL_3RD_PARTY = $(PERL) $(DE_EPAGES)/Installer/Scripts/install3rdParty.pl
UPDATE_EPAGESJ = $(PERL) $(DE_EPAGES)/Installer/Scripts/update-epagesj.pl
UPDATE_NODEJS = $(PERL) $(DE_EPAGES)/Installer/Scripts/update-nodejs.pl
EPNODE6     = $(PERL) $(EPAGES_PERL)/bin/epnode6.pl

# device size in MByte
DATSIZE = 100
LOGSIZE = 50

makefile: Makefile.PL
	$(PERL) Makefile.PL
	@$(ECHONL) "Please restart '$(MAKE)' again, makefile was updated." && $(PERL) -e "exit 1;"

test_store: makefile
	$(PERL) -e "exit ('$(STORE)' eq 'YourStore' ? 1 : 0);"

stop: makefile
	$(STOP_EPAGES)

start: makefile
!ifdef WINDOWS
	$(START_EPAGES)
!else
	IGNORE_INI=1 $(START_EPAGES)
!endif

stop_cron: makefile
	$(STOP_CRON)

start_cron: makefile
	$(START_CRON)

doc: makefile
	$(PERL) $(DE_EPAGES)/SourceDoc/Scripts/DocDir.pl -source $(EPAGES_CARTRIDGES) -target $(SOURCEDOC) -title "$(EPAGES_VERSION)" -ext pm -date "$(SOURCEDOCDATE)" $(EPAGES_CARTRIDGES)\DE_EPAGES

restart: makefile stop start

purge_configuration:
	$(DEL) $(EPAGES_CONFIG)\*.ept
	$(DEL) $(EPAGES_CONFIG)\*\*.ept
	$(DEL) $(EPAGES_CONFIG)\*.initial
	$(DEL) $(EPAGES_CONFIG)\*\*.initial
	$(DEL) $(EPAGES_CONFIG)\*~
	$(DEL) $(EPAGES_CONFIG)\*\*~

clean: makefile
!ifdef WINDOWS
	del /Q /S .*#* *.pdb
	dir /S /B /A:D | grep "Generated$$" | xargs "$(RMDIR)"
	dir /S /B /A:-D | grep "makefile$$" | xargs "$(DEL)"
!endif

test: makefile test_store
	$(PERL) $(DE_EPAGES)/Installer/Scripts/runTests.pl -storename $(STORE)

delete_tables: test_store
	$(DROPTABLES) -storename $(STORE)

cleanfiles_global: makefile
	$(EMPTY_DIR) $(EPAGES_WEBROOT)\_MONITOR_
	$(EMPTY_DIR) $(EPAGES_STORES)\_MONITOR_
	$(EMPTY_DIR) $(EPAGES_SHARED)\Static
	$(DEL) $(EPAGES_LOG)\*

install_storetype:
	$(PERL) $(DE_EPAGES)/Installer/Scripts/installStoreType.pl $(CARTRIDGE) -storetype $(STORE_TYPE) -version $(EPAGES_VERSION_NUMBER)
	$(PERL) $(DE_EPAGES)/JQuery/Scripts/DictionaryConverter.pl -cartridge $(CARTRIDGE) -storetype $(STORE_TYPE) -version $(EPAGES_VERSION_NUMBER)
!ifneq ("$(DOJOBUILD)", "0")
	$(MAKE) build_dojo STORE_TYPE=$(STORE_TYPE)
!endif
!ifneq ("$(UIBUILD)", "0")
	$(MAKE) build_ui STORE_TYPE=$(STORE_TYPE)
!endif

cleanfiles_storetype:
	$(DEL) $(EPAGES_CONFIG)\StoreTypes.d\$(EPAGES_VERSION_NUMBER)\$(STORE_TYPE).conf
	$(RMDIR) $(EPAGES_WEBROOT)\StoreTypes\$(EPAGES_VERSION_NUMBER)\$(STORE_TYPE)

reinstall_storetype: makefile cleanfiles_storetype install_storetype

cleanfilesdb: makefile test_store
	$(RMDIR) $(EPAGES_WEBROOT)\$(STORE)
	$(RMDIR) $(EPAGES_STORES)\$(STORE)
	$(DEL) $(EPAGES_CONFIG)\Cartridges.d\$(STORE).conf

cleandb: makefile test_store
	$(PERL) $(DE_EPAGES)/WebInterfacePoolDB/Scripts/deleteStore.pl -storename $(STORE)
	$(MAKE) delete_tables STORE=$(STORE)

import_store: test_store
	@$(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/store.pl -sitename $(SITE_NAME) -action insert -storename $(STORE)

import_distributor:
	$(IMPORT) $(DE_EPAGES)/ShopConfiguration/Database/XML/Distributor.xml
!ifneq ("$(BASE_SITE_TYPE)", "FlexSite")
	$(IMPORT) $(DE_EPAGES)/ShopConfiguration/Database/XML/DistributorStore.xml
!endif

import_shoptypes: makefile test_store
	$(IMPORT) -path $(PROVIDER_PATH) $(DE_EPAGES)/ShopConfiguration/Database/XML/DistributorShopTypes.xml

install_demoshop: makefile
	$(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/createShop.pl \
		-wsuser $(PROVIDER_PATH)/Users/$(PROVIDER_USER) -passwd $(PROVIDER_PASSWD) \
		-shoptype $(DEMOSHOP_SHOPTYPE) -storename $(STORE) \
		-alias $(DEMOSHOP_ALIAS) -scriptname $(DEMOSHOP_ALIAS)
	$(PERL) $(DE_EPAGES)/RemoteSearch/Scripts/manageIndex.pl -storename $(STORE) -shop $(DEMOSHOP_ALIAS) -update
	$(MAKE) permissions PERM_ARGS=-u SECTION=webroot

demoshop_shopwizard:
	$(PERL) $(DE_EPAGES)/ShopWizard/Scripts/runWizard.pl -storename $(STORE) -shop $(DEMOSHOP_ALIAS) -config $(EPAGES_CONFIG)/ShopWizard.conf -nooutput

uninstall_demoshop: makefile
	$(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/deleteShop.pl -wsuser $(PROVIDER_PATH)/Users/$(PROVIDER_USER) -passwd $(PROVIDER_PASSWD) -alias $(DEMOSHOP_ALIAS)

install_diagnostics: makefile test_store
	cd $(DE_EPAGES)\Diagnostics && $(PERL) Makefile.PL
	cd $(DE_EPAGES)\Diagnostics && $(MAKE) install STORE=$(STORE) EPAGES_VERSION=$(EPAGES_VERSION_NUMBER)

install_store: makefile test_store
	$(INSTALLDB) -storename $(STORE) -sitename $(SITE_NAME)
	$(MAKE) synchronize STORE=$(STORE)
!ifneq ("$(STORE)", "Site")
	-$(PERL) $(DE_EPAGES)/RemoteSearch/Scripts/remoteSearch.pl -storename $(STORE) -state on
!endif
	$(MAKE) permissions PERM_ARGS=-u SECTION=webroot
	$(MAKE) permissions PERM_ARGS=-u SECTION=stores

synchronize: makefile test_store
!ifndef EPAGES_IGNORE_SITE
	$(SYNC) -storename $(STORE) -sitename $(SITE_NAME)
!endif

create_store_conf:
	$(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/createStoreConf.pl -storename $(STORE) -storetype $(STORE_TYPE)

new_store:
	$(MAKE) create_store_conf create_db $(IMPORT_STORE) install_store STORE=$(STORE) STORE_TYPE=$(STORE_TYPE) BACKUP_NAME=$(BACKUP_NAME)

install_pooldb: makefile stop stop_cron
	$(DEL) $(EPAGES_CONFIG)\ASPool.db
	$(DEL) $(EPAGES_CONFIG)\Cartridges.d\ASPoolDB.conf
	$(INSTALLDB) -storename ASPoolDB
	$(MAKE) permissions start PERM_ARGS=-u

install_cpan: makefile
	$(IF_EXIST) $(MODULES_INI) $(DO) $(MAKE) install_cpan_epages

install_cpan_epages:
	$(INSTALL_CPAN) CPAN::EPAGES
	$(MAKE) permissions PERM_ARGS=-u

install: makefile
	$(IF_EXIST) $(MODULES_INI) $(DO) $(MAKE) stop install_cpan start
	$(MAKE) update_os
	$(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/createStoreConf.pl -storename PatchSystemInfoDB -storelogin usr_patch -backuphost none
!ifndef EPAGES_IGNORE_SITE
	$(MAKE) create_store_conf install_storetype STORE=Site STORE_TYPE=$(BASE_SITE_TYPE)
	$(MAKE) create_db install_store STORE=Site STORE_TYPE=$(BASE_SITE_TYPE) DATSIZE=50 LOGSIZE=20
!endif
!ifndef EPAGES_IGNORE_STORE
	$(MAKE) create_store_conf install_storetype STORE=Store STORE_TYPE=$(BASE_STORE_TYPE)
	$(MAKE) create_db $(IMPORT_STORE) install_store STORE=Store
!endif
!ifndef EPAGES_IGNORE_SITE
	$(MAKE) import_distributor STORE=Site
	$(MAKE) import_shoptypes STORE=Site
!endif
!ifndef EPAGES_IGNORE_STORE
!ifndef EPAGES_IGNORE_DEMOSHOP
	$(MAKE) install_demoshop STORE=Store DEMOSHOP_SHOPTYPE=$(DEMOSHOP_SHOPTYPE)
!endif
!endif
!ifdef EPAGES_BUSINESS_UNITS
	$(MAKE) $(EPAGES_BUSINESS_UNITS)
!endif
	$(MAKE) start_cron

reinstall: makefile uninstall
	$(DEL) $(EPAGES_CONFIG)/Database.d/Store.conf
	$(MAKE) create_store_conf STORE=Store STORE_TYPE=$(STORE_TYPE)
	$(MAKE) install UPDATE_OS=$@ STORE_TYPE=$(STORE_TYPE) DEMOSHOP_SHOPTYPE=$(DEMOSHOP_SHOPTYPE)
!ifndef EPAGES_IGNORE_SITE
	$(MAKE) install_diagnostics STORE=Site EPAGES_VERSION_NUMBER=$(EPAGES_VERSION_NUMBER)
!endif
!ifndef EPAGES_IGNORE_STORE
	$(MAKE) install_diagnostics STORE=Store EPAGES_VERSION_NUMBER=$(EPAGES_VERSION_NUMBER)
!endif

reinstall_fast:
	$(MAKE) reinstall DEMOSHOP_SHOPTYPE=MinDemo STORE_TYPE=MinStore
	$(MAKE) demoshop_shopwizard STORE=Store

uninstall: makefile cleanfiles_global
	$(MAKE) install_pooldb
	$(DEL) $(EPAGES_CONFIG)\EbayCategories.db
!ifdef EPAGES_BUSINESS_UNITS
	$(MAKE) $(EPAGES_BUSINESS_UNITS) UNINSTALL_BU=1
!endif
!ifndef EPAGES_IGNORE_SITE
	$(MAKE) drop_db cleanfilesdb cleanfiles_storetype STORE=Site STORE_TYPE=$(BASE_SITE_TYPE) EPAGES_VERSION_NUMBER=$(EPAGES_VERSION_NUMBER)
!endif
!ifndef EPAGES_IGNORE_STORE
	$(MAKE) drop_db cleanfilesdb cleanfiles_storetype STORE=Store STORE_TYPE=$(BASE_STORE_TYPE) EPAGES_VERSION_NUMBER=$(EPAGES_VERSION_NUMBER)
!endif

build_dojo:
!ifneq ("$(DOJOBUILD)", "0")
	$(PERL) $(EPAGES_CARTRIDGES)/DE_EPAGES/Dojo/Scripts/build.pl -storetype $(STORE_TYPE) -version $(EPAGES_VERSION_NUMBER) -config Dojo/Scripts/build2.conf
	$(PERL) $(EPAGES_CARTRIDGES)/DE_EPAGES/Dojo/Scripts/build.pl -storetype $(STORE_TYPE) -version $(EPAGES_VERSION_NUMBER)
!endif

build_ui:
!ifneq ("$(UIBUILD)", "0")
	$(PERL) $(EPAGES_CARTRIDGES)/DE_EPAGES/Presentation/Scripts/buildUi.pl -storetype $(STORE_TYPE) -version $(EPAGES_VERSION_NUMBER)
!endif

reinstall_store: makefile test_store cleandb cleanfilesdb install_store

# create databases

create_db: makefile
	$(CREATEDB) -storename $(STORE) -datsize $(DATSIZE) -logsize $(LOGSIZE) -connection $(BACKUP_NAME)

drop_db: makefile
	$(DROPDB) -storename $(STORE)

# patch

close_store:
	$(STOREREDIRECT) -storename $(STORE) -redirect StoreClosed.html

open_store:
	$(STOREREDIRECT) -storename $(STORE) -remove

patch_store: makefile test_store
	$(PATCHDB)   -nosync -storename $(STORE)
	$(INSTALLDB) -nosync -storename $(STORE)

update_latest: makefile
	cvs -q update -A -d -P
	$(MAKE) permissions SECTION=cartridges
	$(MAKE) restart

latest: makefile update_latest reinstall
renew: latest

update_stable: makefile
	cvs -q update -d -P -r stable
	$(MAKE) permissions SECTION=cartridges
	$(MAKE) restart

stable: makefile update_stable reinstall

update_os:
!ifndef SKIP_UPDATE_OS
!ifdef WINDOWS
	$(INSTALL_3RD_PARTY) graphviz jdk mongodb mp3splt nodejs
	$(UPDATE_EPAGESJ) -version $(EPAGESJ_VERSION)
	$(UPDATE_NODEJS) -version $(EPAGES_NODEJS_VERSION)
!else
!ifeq ("$(UPDATE_OS)", "reinstall")
	/var/epages/install-RPM.sh unzip
	if [ -f "$(PATCH_DIR)/sh/patch.conf" ] ; then\
 PATH="$(PATCH_DIR)"/sh/EPAGES_RELEASE/var/epages:/var/epages:$$PATH patch-sh.sh -d "$(PATCH_DIR)"/sh ; fi
	rpm -qp http://ep-server/yum/$(EPAGES_VERSION_NUMBER)/epages-version.noarch.rpm --qf '[%{VERSION}]' 2>/dev/null\
 && { echo ; $(EPAGES)/bin/rpmify-epages.sh -repo http://ep-server/yum/$(EPAGES_VERSION_NUMBER);\
      ENABLE_REPO=epages-update-$(EPAGESJ_VERSION) /var/epages/install-RPM.sh --update epages-j; }\
 || $(UPDATE_EPAGESJ) -version $(EPAGESJ_VERSION)
	ENABLE_REPO=epages-update-$(EPAGES_VERSION_NUMBER) /var/epages/install-RPM.sh --update graphviz mp3splt
	ENABLE_REPO=epages-update-$(EPAGES_VERSION_NUMBER) /var/epages/install-RPM.sh --update epages-nodejs
!endif
!endif
	$(MAKE) check_epagesj
!endif

build_patch_sh:
!ifndef WINDOWS
	if type -p build-patch-sh.sh ; then rm -rf "$(PATCH_DIR)"/sh ;\
 build-patch-sh.sh -r "$(EPAGES_TAG)" -P "$(PATCH_TAG)" -t "$(PATCH_DIR)"/sh ; fi
!endif

permissions:
!ifndef WINDOWS
	$(ETC_INITD) perm admin $(PERM_ARGS)
!ifdef SECTION
	$(ETC_INITD) perm $(SECTION) $(PERM_ARGS)
!endif
!endif

# epages business units

Site:
Store:

MultiStore Master:
!ifdef UNINSTALL_BU
	$(MAKE) uninstall_multistore
!else
	$(MAKE) install_multistore
!ifndef EPAGES_IGNORE_DEMOSHOP
	$(MAKE) install_multistore_demo
!endif
!endif

FlexStore:
!ifdef UNINSTALL_BU
	$(MAKE) uninstall_flexstore
!else
	$(MAKE) install_flexstore
!endif

FlexSite:
!ifdef UNINSTALL_BU
	$(MAKE) uninstall_flexsite
!else
	$(MAKE) install_flexsite
!ifndef WINDOWS
	/var/epages/ini-config.sh -i -f $(EPAGES_CONFIG)/Scheduler.conf -s LOOPS -k Store -v "-storename Site"
!endif
!endif

install_multistore: makefile
!ifneq ("$(MASTER_NAME)", "$(MULTISTORE_NAME)")
	$(IF_EXIST) $(MODULES_INI) $(DO) $(MAKE) stop install_cpan start
	$(MAKE) update_os
	$(PERL) $(DE_EPAGES)/ShopConfiguration/Scripts/createStoreConf.pl -storename PatchSystemInfoDB -storelogin usr_patch -backuphost none
	$(MAKE) create_store_conf install_storetype STORE=$(SITE_NAME) STORE_TYPE=$(MULTISTORESITE_TYPE)
	$(MAKE) create_db install_store STORE=$(SITE_NAME) STORE_TYPE=$(MULTISTORESITE_TYPE)
	$(MAKE) new_store STORE=$(SITE_NAME) STORE_TYPE=$(MULTISTORESITE_TYPE)
	$(MAKE) import_multistoresite_distributor STORE=$(SITE_NAME)
	$(MAKE) import_multistoresite_shoptypes STORE=$(SITE_NAME)
	$(MAKE) synchronize STORE=$(SITE_NAME)
	$(MAKE) create_store_conf install_storetype STORE=$(MASTER_NAME) STORE_TYPE=$(MASTER_TYPE)
	$(MAKE) create_store_conf install_storetype STORE=$(MULTISTORE_NAME) STORE_TYPE=$(MULTISTORE_TYPE)
	$(MAKE) new_store STORE=$(MASTER_NAME) STORE_TYPE=$(MASTER_TYPE)
	$(MAKE) new_store STORE=$(MULTISTORE_NAME) STORE_TYPE=$(MULTISTORE_TYPE)
	$(MAKE) import_multistore_distributor
	$(MAKE) import_multistore_shoptypes
!else
	@echo  Master and MultiStore have to be installed at different databases.
!endif

import_multistoresite_distributor:
	$(IMPORT) $(DE_EPAGES)/ShopConfiguration/Database/XML/Distributor.xml

import_multistoresite_shoptypes:
	$(IMPORT) -path $(PROVIDER_PATH) $(DE_EPAGES)/ShopConfiguration/Database/XML/DistributorShopTypes.xml

uninstall_multistore: makefile
	$(MAKE) cleanfiles_storetype STORE_TYPE=$(MASTER_TYPE)
	$(MAKE) cleanfiles_storetype STORE_TYPE=$(MULTISTORE_TYPE)
	$(MAKE) cleanfiles_storetype STORE_TYPE=$(MULTISTORESITE_TYPE)
	$(MAKE) drop_db cleanfilesdb STORE=$(MASTER_NAME)
	$(MAKE) drop_db cleanfilesdb STORE=$(MULTISTORE_NAME)
	$(IF_EXIST) $(EPAGES_CONFIG)/Database.d/Site.conf $(DO) $(MAKE) drop_db cleanfilesdb STORE=$(SITE_NAME)
	$(DEL) $(EPAGES_CONFIG)/Database.d/Site.conf
	$(MAKE) create_store_conf STORE=Site STORE_TYPE=$(BASE_SITE_TYPE)

reinstall_multistore: makefile
	$(MAKE) uninstall_multistore
	$(MAKE) install_multistore UPDATE_OS=reinstall

reinstall_multistore_complete: makefile
	$(MAKE) uninstall_multistore
	$(MAKE) install_multistore_complete UPDATE_OS=reinstall

install_multistore_complete: makefile
	$(DEL) $(EPAGES_CONFIG)/Database.d/Site.conf
	$(MAKE) create_store_conf STORE=Site STORE_TYPE=$(MULTISTORESITE_TYPE)
	$(MAKE) install_multistore
	$(MAKE) install_multistore_demo
	$(MAKE) install_diagnostics STORE=$(MASTER_NAME)
	$(MAKE) install_diagnostics STORE=$(MULTISTORE_NAME)
	$(MAKE) install_diagnostics STORE=$(SITE_NAME)

install_multistore_demo: makefile
	$(MAKE) install_mastershop
	$(MAKE) install_subshop SUBSHOP_ALIAS=$(SUBSHOP_ALIAS_DROPSHIPPING) SUBSHOP_SHOPTYPE=$(SUBSHOP_SHOPTYPE_DROPSHIPPING)
	$(MAKE) install_subshop SUBSHOP_ALIAS=$(SUBSHOP_ALIAS_ERETAIL) SUBSHOP_SHOPTYPE=$(SUBSHOP_SHOPTYPE_ERETAIL)
	$(MAKE) assign_subshop_to_mastershop SUBSHOP_ALIAS=$(SUBSHOP_ALIAS_DROPSHIPPING) ORDER_INTEGRATION=$(ORDER_INTEGRATION_DROPSHIPPING)
	$(MAKE) assign_subshop_to_mastershop SUBSHOP_ALIAS=$(SUBSHOP_ALIAS_ERETAIL) ORDER_INTEGRATION=$(ORDER_INTEGRATION_ERETAIL)

install_mastershop: makefile
	$(MAKE) install_demoshop STORE=$(MASTER_NAME) DEMOSHOP_ALIAS=$(MASTERSHOP_ALIAS) PROVIDER_PATH=$(MASTER_PROVIDER_PATH) PROVIDER_USER=$(MASTER_PROVIDER_USER) DEMOSHOP_SHOPTYPE=$(MASTERSHOP_SHOPTYPE)
	$(PERL) $(DE_EPAGES)/Shop/Scripts/setMaxFeature.pl -storename $(MASTER_NAME) -shopname $(MASTERSHOP_ALIAS) -featurename MultiStoreMaster -featurevalue 1
	$(PERL) $(DE_EPAGES)/MultiStoreMaster/Scripts/ExportMaster.pl -storename $(MASTER_NAME) -exportall

install_subshop: makefile
	$(MAKE) install_demoshop STORE=$(MULTISTORE_NAME) DEMOSHOP_ALIAS=$(SUBSHOP_ALIAS) PROVIDER_PATH=$(MULTISTORE_PROVIDER_PATH) PROVIDER_USER=$(MULTISTORE_PROVIDER_USER) DEMOSHOP_SHOPTYPE=$(SUBSHOP_SHOPTYPE)

import_multistore_shoptypes: makefile
	$(PERL) $(DE_EPAGES)/Object/Scripts/import.pl -storename $(SITE_NAME) -path $(MASTER_PROVIDER_PATH) $(DE_EPAGES)/MultiStoreProvider/Database/XML/DistributorShopTypesDropShipping.xml
	$(PERL) $(DE_EPAGES)/Object/Scripts/import.pl -storename $(SITE_NAME) -path $(MASTER_PROVIDER_PATH) $(DE_EPAGES)/MultiStoreProvider/Database/XML/DistributorShopTypesERetail.xml

import_multistore_distributor: makefile
	$(PERL) $(DE_EPAGES)/Object/Scripts/import.pl -storename $(SITE_NAME) $(DE_EPAGES)/MultiStoreProvider/Database/XML/DistributorMultiStore.xml

assign_subshop_to_mastershop: makefile
	$(PERL) $(DE_EPAGES)/MultiStoreProvider/Scripts/assignSubShopToMasterShop.pl -mastershop $(MASTERSHOP_ALIAS) -subshop $(SUBSHOP_ALIAS) -affiliateshopid $(SUBSHOP_ALIAS) -orderintegration $(ORDER_INTEGRATION)

install_flexstore:
	cd $(DE_EPAGES)\Flex && $(PERL) Makefile.PL
	cd $(DE_EPAGES)\Flex && $(MAKE) install_service update_scheduler

uninstall_flexstore:
	cd $(DE_EPAGES)\Flex && $(PERL) Makefile.PL
	cd $(DE_EPAGES)\Flex && $(MAKE) uninstall_service

install_flexsite:
uninstall_flexsite:

# epages java
check_epagesj: makefile
	$(PERL) $(DE_EPAGES)/EPagesJ/Scripts/checkEPagesJ.pl -version $(EPAGESJ_VERSION)

activate_java_search:
	-$(PERL) $(DE_EPAGES)/RemoteSearch/Scripts/remoteSearch.pl -storename $(STORE) -state on
	$(PERL) $(DE_EPAGES)/RemoteSearch/Scripts/manageIndex.pl -storename $(STORE) -all -update

add_mongo_service:
	$(PERL) $(DE_EPAGES)/Installer/Scripts/addMongoService.pl

add_epagesj_services:
	$(PERL) $(DE_EPAGES)/Installer/Scripts/addJavaServices.pl
#
# END
#
