#-----BEGIN PGP SIGNATURE-----
#Version: GnuPG v1.2.6 (GNU/Linux)
#Comment: 2008-11-24 ePages Software GmbH (release key) <rnd@epages.de>
#
#iD8DBQBS8j7Sl5jMabHSgyARAuqcAJsHMfpBx+4zmm9CWCpYYRt13g38rwCggQDx
#hH9mkw5dCRt5V5LjulvuWVo=
#=5Mcz
#-----END PGP SIGNATURE-----
#========================================================================================
# package      DE_EPAGES::WebService::Samples::Server::HelloResource
# state        private
# base         DE_EPAGES::WebService::API::Resource::BaseResource
#----------------------------------------------------------------------------------------
# description  Very basic example for an implementation of a REST resource.
#               Implements the methods GET, PUT, DELETE and POST.
#========================================================================================
package DE_EPAGES::WebService::Samples::Server::HelloResource;
use base DE_EPAGES::WebService::API::Resource::BaseResource;

use strict;

use constant MAX_RAND => 100000;
my %Items;

sub get {
    my $self = shift;
    my ($ID) = @_;

    return $Items{$ID};
}

sub put {
    my $self = shift;
    my ($ID, $Data) = @_;

    $Items{$ID} = $Data;
    return;
}

sub delete {
    my $self = shift;
    my ($ID) = @_;

    delete $Items{$ID};
    return;
}

sub post {
    my $self = shift;
    my ($Data) = @_;

    my $ID = int(rand(MAX_RAND)); # always generate a new id
    $ID = int(rand(MAX_RAND)) while exists $Items{$ID};
    $Items{$ID} = $Data;
    return $ID;
}

1;
